<?php declare(strict_types=1);

namespace Plugin\css_zubehoer\src\cssPlugin;

use JTL\Cache\JTLCacheInterface;
use JTL\DB\DbInterface;
use JTL\Shop;
use JTL\Helpers\Text;
use JTL\Cart\CartHelper;
use JTL\Plugin\PluginInterface;
use JTL\Helpers\Product;
use JTL\Catalog\Product\Artikel;
use JTL\Minify\MinifyService;
use JTL\Shopsetting;
use JTL\Language\LanguageHelper;
use JTL\Customer\CustomerGroup;
use JTL\Catalog\Currency;

#class Artikel extends Artikel {
#	public $staffelpreisJson;
#	public $zubehoerInputType;
#}



class cssPlugin extends Functions {
	/**
	 * @var DbInterface
	 */
	private static $_db;

	/**
	 * @var PluginInterface
	 */
	private static $_extension;

	/**
	 * @var JTLCacheInterface
	 */

	public static $_cache = null;
	public static $_instance = null;
	public static $_config = null;
	public static $_plugin = null;
	public static $_hasJsCss = false;
	public static $_staffelpreisJson = array();
	public static $_zubehoerInputType = array();



	public static $_debug = false;

	public static $_error = array ();
	public static $_hinweis = array ();
	public static $artikelNotInsertArr = array();
	public static $artikelIsInsertArr = array();

	public function __construct(PluginInterface $extension, DbInterface $db, JTLCacheInterface $cache) {

		self::$_extension = $extension;
		self::$_plugin = $extension;
		self::$_db = $db;
		self::$_cache = parent::setCache($cache);
		self::$_instance = $this;
		parent::$_plugin = self::$_plugin;
		define('css_zubehoer_dir',PFAD_ROOT.PFAD_COMPILEDIR.self::$_plugin->getPluginID());

		if(Shop::isFrontend() === false || (int) date("G") == rand(6, 22)) {
			parent::checkLicence ($extension);
		}
	}

	public static function getInstance(PluginInterface $extension, DbInterface $db=null, JTLCacheInterface $cache=null) {
		if(empty($db)) $db = Shop::Container()->getDB();
		if(empty($cache)) $cache = Shop::Container()->getCache();
		$obj = (self::$_instance === null) ? new self ( $extension,$db,$cache ) : self::$_instance;
		parent::$_plugin = self::$_extension;
		parent::$_instance = self::$_instance;
		parent::$_error = &self::$_error;
		self::$_config = parent::$_config = self::getConfig();
		return $obj;
	}


	public static function setConfig($config = array()) {
// @TODO some functions to make my Config fine


		parent::setConfig($config);

		$minify          = new MinifyService();
		$minify->flushCache();

// here we clear the config cache
		self::$_cache->flushTags([self::getCacheTag()]);
		self::$_config=null;
// we get the new Config
		self::getConfig();
	}

	public static function getConfig() {
		if(!empty(self::$_config)) return self::$_config;
		if(( $oConfig = self::$_cache->get(self::$_plugin->getPluginID() . '_Config')) === false) {
			$oConfig = parent::getConfig();

// @TODO some functions to make my Config fine
			if(!empty($oConfig->framework) && $oConfig->framework=='CU') {
				$oConfig->framework='custom';
			}


// here we cache the config
			self::$_cache->set(self::$_plugin->getPluginID() . '_Config', $oConfig, [CACHING_GROUP_OPTION, parent::getCacheTag()]);
			self::$_config = $oConfig;
		}

		return $oConfig;
	}


	private function getSmarty() {
		return Shop::Smarty();
	}


	public function setStaffelpreisJson($kArtikel,$value) {


		if(!empty($kArtikel)) {
			self::$_staffelpreisJson[$kArtikel] = $value;
		} else {
		}
	}

	public function getStaffelpreisJson($kArtikel) {
		if(!empty(self::$_staffelpreisJson[$kArtikel])) {
			return self::$_staffelpreisJson[$kArtikel];
		} else return "";
	}

	public function setZubehoerInputType($kArtikel, $value) {
		if(!empty($kArtikel)) {
			self::$_zubehoerInputType[$kArtikel] = $value;
		}
	}

	public function getZubehoerInputType($kArtikel=0) {
		if(!empty(self::$_zubehoerInputType[$kArtikel])) {
			return self::$_zubehoerInputType[$kArtikel];
		} else return "number";
	}

	public function stopRedirectToBasket() {
		$conf      = Shop::getSettings([CONF_GLOBAL]);
		if(isset($conf['global']['global_warenkorb_weiterleitung'])) {
			$conf['global']['global_warenkorb_weiterleitung'] = 'N';
			Shopsetting::getInstance()->offsetSet('global',$conf['global']);
		}
	}


	public function getXsellGroups() {
		$db = parent::getDB ();
		return $db->query ( "select  UPPER(left(cName,1)) as firstLetter, cName, kXSellGruppe from txsellgruppe where kSprache=" . LanguageHelper::getDefaultLanguage()->kSprache . "  order by cName", 2 );
	}


	public function getXsellGroupFirstLetters() {
		$db = parent::getDB ();
		return $db->executeQuery ( "select UPPER(left(cName,1)) as firstLetter from txsellgruppe  where  kSprache=" . LanguageHelper::getDefaultLanguage()->kSprache . "  group by firstletter order by cName", 2 );
	}


	public static function xSellGroupName($zubehoerXsellGroup,$kSprache=0) {
		$db = self::$_db;
		$query = 'select cName from txsellgruppe where kSprache='.$kSprache.' AND kXSellGruppe='.$zubehoerXsellGroup;
		$obj = $db->query($query,1);
		if($obj !== null && $obj) return $obj->cName;
		return false;
	}

	public function sortDownXselling($a, $b) {
		if (ord ( self::getZubehoerInputType($a->kArtikel) ) > ord ( self::getZubehoerInputType($b->kArtikel) )) return 1;
		return 0;
	}

	public function sortUpXselling($a, $b) {
		if (ord ( self::getZubehoerInputType($a->kArtikel) ) < ord ( self::getZubehoerInputType($b->kArtikel) )) return 1;
		return 0;
	}

	public function sortNumberUp($a, $b) {
		if ((int) $a->nSort  > (int) $b->nSort ) return 1;
		return 0;
	}

	public function sortNumberDown($a, $b) {
		if ((int) $a->nSort  < (int) $b->nSort ) return 1;
		return 0;
	}

	public function zubehoerList($list = '') {
		$arr = '';
		$listarr = array_map ( function ($a) {
			return trim ( $a );
		}, (array) explode ( ",", $list ) );
		if (is_array ( $listarr )) {
			$arr = array ();
			foreach ( $listarr as $li ) {
				$artikelObj = self::getArtikeldaten ( null, $li );
				if ($artikelObj && $artikelObj->nIstVater == 0 && self::canGet ( $artikelObj )) {
					if (isset ( $artikelObj->FunktionsAttribute['zubehoertype'] ) && $artikelObj->FunktionsAttribute['zubehoertype'] == 'number') {
						self::setZubehoerInputType($artikelObj->kArtikel,'text');
						die("File: ".__FILE__."<br>\nFunction: ".__FUNCTION__."<br>\nLine: ".__LINE__."<br>\n");
					} else {
						self::setZubehoerInputType($artikelObj->kArtikel,'checkbox');
					}
					$arr[] = $artikelObj;
				}
			}
		}
		if (count ( $arr )) {
			usort ( $arr, self::class . '::sortXselling');
			return $arr;
		}
		return false;
	}

	public function canGet($artikel) {
		if ((($artikel->fLagerbestand <= 0 && $artikel->cLagerBeachten = 'Y'))) {
			return false;
		}
		return true;
	}

	public function getStaffel($artikelObj) {
		if(is_array($artikelObj->staffelPreis_arr) && count($artikelObj->staffelPreis_arr)) {
			$arr = array('0' => array(),'1' => array());
			foreach($artikelObj->staffelPreis_arr as $item) {
				$arr[0][$item['nAnzahl']] =  $item['fStaffelpreis'][0];
				$arr[1][$item['nAnzahl']] =  $item['fStaffelpreis'][1];
			}
			return \json_encode($arr);
		}
		return false;
	}



	public function getXselling($StartArtikelObj, $kXSellGruppe=0 ,$widthCheckbox=true,$widthStartArtikel=true, $limit=10, $rand=false,$OnlyFromArticle = false) {
		$arr = array();

		if(empty($StartArtikelObj) || empty($StartArtikelObj->kArtikel)
			|| (int) $StartArtikelObj->kArtikel==0 ||  ((int) $StartArtikelObj->nIstVater && !(int) $StartArtikelObj->kVariKindArtikel) ) return false;

		if((int) $StartArtikelObj->kVariKindArtikel>0) {
			$kArtikel = (int) $StartArtikelObj->kVariKindArtikel;
		} else {
			$kArtikel = (int) $StartArtikelObj->kArtikel;
		}


		if(empty($kArtikel) || (int) $kArtikel == 0) return false;

		$oStartArtikel = new Artikel();
		$oStartArtikel->fuelleArtikel((int) $kArtikel,Artikel::getDefaultOptions ());


		$db = self::$_db;
		$textfieldFound=false;
		$cSQLLager='';
		$quantity=1;
		$cNotIn ='';
		$aZubehoer = array();
		if($rand === true) {
			$order = " order by RAND(".time().") ";
		} else {
			$order= "";
		}
		if((int) $limit) {
			$limit = " LIMIT ".(int) $limit . " ";
		}	else {
			$limit = '';
		}


		$_POST['jtl_token'] = $_SESSION['jtl_token'];

		if(($oStartArtikel->nIstVater && !$oStartArtikel->kVariKindArtikel) ) return;

		if((int) $oStartArtikel->kVariKindArtikel>0) {
			$kArtikel = (int) $oStartArtikel->kVariKindArtikel;
		} else {
			$kArtikel = (int) $oStartArtikel->kArtikel;
		}

		if($OnlyFromArticle === true) {
			$OnlyFromArticle = " and kArtikel = ".(int)  $kArtikel." ";
		} else {
			$OnlyFromArticle ='';
		}

		if($widthStartArtikel===false && isset($oStartArtikel->FunktionsAttribute['zubehoer']) && !empty($oStartArtikel->FunktionsAttribute['zubehoer'])) {
			$aZubehoer = explode(",",$oStartArtikel->FunktionsAttribute['zubehoer']);
			if(is_array($aZubehoer) !== false) {
				$a = array();
				$b = array();
				foreach($aZubehoer as $value) {
					$obj = $db->query("SELECT kArtikel as kXSellArtikel FROM tartikel WHERE cArtNr='".trim($value)."'",1);
					if($obj !== null && $obj->kXSellArtikel > 0) {
						$b[] = $obj->kXSellArtikel;
						$a[] = $obj;
					}
				}
				if(count($b)) {
					$aZubehoer = $a;
					$cNotIn = " AND kXSellArtikel NOT IN(". join(",",$b).") ";
				}
			}
		}

		$xSelling = new \stdClass ();
		$xSelling->Standard = new \stdClass ();


		$xsellObj = $db->query('SELECT kXSellArtikel FROM txsell WHERE kXSellGruppe= '.(int) $kXSellGruppe.$OnlyFromArticle.$cNotIn.' group by kXSellArtikel '. $order. $limit,2);

		$xsellObj = array_merge($xsellObj,$aZubehoer);


		if ($xsellObj!==null && count ( $xsellObj ) > 0) {
			$arr = array ();

			self::setStaffelpreisJson($oStartArtikel->kArtikel, $this->getStaffel($oStartArtikel));


			if($widthStartArtikel) {
				$arr[] = $oStartArtikel;
			}

			$oArtikelOptionen = Artikel::getDefaultOptions ();
			foreach ( $xsellObj as $xs ) {
				$ArtikelObj = new Artikel ();
				$ArtikelObj->fuelleArtikel ( (int) $xs->kXSellArtikel, $oArtikelOptionen );

				if ((int) $ArtikelObj->kArtikel) {

					if (isset($ArtikelObj->kEigenschaftKombi) && $ArtikelObj->kEigenschaftKombi > 0) {
						$oEigenschaftwerte_arr = Product::getVarCombiAttributeValues((int)$ArtikelObj->kArtikel);
					} else $oEigenschaftwerte_arr = Product::getSelectedPropertiesForArticle((int) $ArtikelObj->kArtikel,false);

					// hier prüfe ich die Mindestbestellmenge hinzugefuegt am 27.01.2024
					if(!$ArtikelObj->aufLagerSichtbarkeit () || count(CartHelper::addToCartCheck($ArtikelObj, (float) $ArtikelObj->fMindestbestellmenge, $oEigenschaftwerte_arr,2))) continue;
					self::setStaffelpreisJson($ArtikelObj->kArtikel, $this->getStaffel($ArtikelObj));
					if ($widthCheckbox) {
						if (isset ($ArtikelObj->FunktionsAttribute['zubehoertype']) && $ArtikelObj->FunktionsAttribute['zubehoertype'] == 'number') {
							self::setZubehoerInputType($ArtikelObj->kArtikel, 'text');
							$textfieldFound = true;
						} else {
							self::setZubehoerInputType($ArtikelObj->kArtikel, 'checkbox');
						}
					}
					$arr[] = $ArtikelObj;
				} else {
					// für notfaelle
				}
			}
		}


		if (isset($arr) && count ( $arr ) ) {
			if($widthCheckbox && $textfieldFound) $arr = self::sortListing($arr);

			return $arr;
		}
		return false;
	}


	public function removeXsellingGroup($args_arr=array(),$group=0) {
		$db = self::$_db;

		if($group > 0 && isset($args_arr['xSelling']->Standard->XSellGruppen)) {
			$arrNames = array();
			$tmpXselling = array();
			$arrGroup = $db->selectArray("txsellgruppe","kXSellGruppe",$group);
			foreach($arrGroup as $obj) {
				$arrNames[]  = $obj->cName;
			}
			foreach($args_arr['xSelling']->Standard->XSellGruppen as $xGruppe) {
				if(in_array( $xGruppe->Name,$arrNames)===false) {
					$tmpXselling[] = $xGruppe;
				} else {
				}
			}
			$args_arr['xSelling']->Standard->XSellGruppen = $tmpXselling;
		}
		return $args_arr;
	}


	public function sortListing($arr=array()) {

		if(self::getConfig()->zubehoerSortierung=='sortUp' && count($arr)>1) {
			usort ( $arr, self::class . '::sortNumberUp');
		} elseif(self::getConfig()->zubehoerSortierung=='sortDown'){
			usort ( $arr, self::class . '::sortNumberDown');
		} elseif(self::getConfig()->zubehoerSortierung=='unten'){
			usort ( $arr, self::class . '::sortDownXselling');
		} else {
			usort ( $arr, self::class . '::sortUpXselling');
		}

		return $arr;
	}

	public function getArtikeldaten($id = '', $artnr = null) {
		global $Einstellungen;

		if ($artnr !== null) {
			$oArtikel = self::$_db->selectSingleRow ( "tartikel", "cArtNr", $artnr );
		}
		// hole aktuellen Artikel
		$AktuellerArtikel = new Artikel ();
		unset ( $oArtikelOptionen );
		$oArtikelOptionen = new \stdClass ();
		$oArtikelOptionen->nMerkmale = 0;
		$oArtikelOptionen->nAttribute = 1;
		$oArtikelOptionen->nArtikelAttribute = 1;
		$AktuellerArtikel->fuelleArtikel ((int) $oArtikel->kArtikel, $oArtikelOptionen );
		if ($AktuellerArtikel->kArtikel) {
			return $AktuellerArtikel;
		}
		return false;
	}


	public function getHeadline($type) {
		$smarty = Shop::Smarty();
		$oArtikel = $smarty->getTemplateVars('Artikel');
		if(!empty($oArtikel->FunktionsAttribute[$type.'_name_'.LanguageHelper::getIso()])) {
			$bundleName = $oArtikel->FunktionsAttribute[$type.'_name_'.LanguageHelper::getIso()];
		} elseif(!empty($oArtikel->VaterFunktionsAttribute[$type.'_name_'.LanguageHelper::getIso()])) {
			$bundleName = $oArtikel->VaterFunktionsAttribute[$type.'_name_'.LanguageHelper::getIso()];
		} else {
			if($type=='bundle') {
				$bundleName = self::$_plugin->getLocalization()->getTranslation('css_bundle_headline');
			} else {
				$bundleName = self::$_plugin->getLocalization()->getTranslation('css_zubehoer_headline');
			}
		}
		return $bundleName;
	}

	public function hookSmartyOutputfilter() {
		if(Shop::getPageType()!=PAGE_ARTIKEL) return;
		$config = self::getConfig();
		$smarty = Shop::Smarty();
		$smarty->assign("cssZubehoerConfig",$config)
		->assign('oCSS_zubehoer',self::$_plugin)
			->assign("oCSS_zubehoerPlugin",$this);

		pq("body")->addClass("css-zubehoer css-zubehoer-".$config->framework);
		if(isset($_POST['xjxfun']) && $_POST['xjxfun']=='tauscheVariationKombi') {
			$oArtikel = $smarty->getTemplateVars('Artikel');
			$oArtikel = self::$_db->select("tartikel","cArtNr",$oArtikel->cArtNr);

			if(isset($oArtikel->FunktionsAttribute['unverkaeuflich']) && $oArtikel->FunktionsAttribute['unverkaeuflich']==1) return;

			if($oArtikel->nIstVater != 1 || ($oArtikel->nIstVater == 1 && $oArtikel->kVariKindArtikel > 0) ) {

			if(!empty($oArtikel->FunktionsAttribute['xselling_accesories']) && (int) $oArtikel->FunktionsAttribute['xselling_accesories'] > 0) {
				$xSellingGroup = (int) $oArtikel->FunktionsAttribute['xselling_accesories'];
				if((int) $config->cssRand > 0 ){
					$limit = (int) $config->cssRand;
				} else {
					$limit = 0;
				}
				$rand = true;
				$OnlyFromArticle = false;
			} else {
				$xSellingGroup = self::getConfig()->zubehoerXsellGroup;
				$OnlyFromArticle = true;
				$limit = 0;
				$rand=false;
			}

				$zubehoerXsellArr = self::getXselling($oArtikel,$xSellingGroup,true,false,$limit,$rand,$OnlyFromArticle);

				// ich kann keinen Artikel im Bundle gebrauchen der eine Variante hat die ausgewählt werden muss.


				if( $oArtikel->inWarenkorbLegbar == 1
					&& !count($oArtikel->oKonfig_arr)
				) {

					if(!empty($oArtikel->FunktionsAttribute['xselling_bundle']) && (int) $oArtikel->FunktionsAttribute['xselling_bundle'] > 0) {
						$xSellingGroup = (int) $oArtikel->FunktionsAttribute['xselling_bundle'];
						if((int) $config->cssRand > 0 ){
							$limit = (int) $config->cssRand;
						} else {
							$limit = 0;
						}
						$rand = true;
						$OnlyFromArticle = false;
					} else {
						$limit = 0;
						$rand = false;
						$OnlyFromArticle = true;
						$xSellingGroup = self::getConfig()->bundleXsellGroup;
					}


					$bundleXsellArr = self::getXselling($oArtikel,$xSellingGroup,false,true,$limit,$rand,$OnlyFromArticle);
				} else $bundleXsellArr=false;




				if($zubehoerXsellArr)	Shop::set(self::$_plugin->getID().'_zubehoerArr', $zubehoerXsellArr);
				if($bundleXsellArr && count($bundleXsellArr)>1)		Shop::set(self::$_plugin->getID().'_bundleArr', $bundleXsellArr);

			}
			$_zubehoerArr = Shop::get(self::$_plugin->getID().'_zubehoerArr');
		}

		$selectedBundleItemArr = explode(",",mb_convert_encoding(htmlentities(parent::getLocalizedLanguage('textArtikelanzahl', ENT_QUOTES)), 'ISO-8859-1', 'UTF-8'));
		if(Shop::has(self::$_plugin->getID().'_bundleArr')) {
			$_bundleArr = Shop::get(self::$_plugin->getID().'_bundleArr');
		}

		if(isset($selectedBundleItemArr) && isset($_bundleArr) && count($selectedBundleItemArr) >= count($_bundleArr)) {
			$selectedBundleItem = $selectedBundleItemArr[count($_bundleArr)];
		}elseif(isset($_bundleArr)) {
			$selectedBundleItem = count($_bundleArr);
		} else {
			$selectedBundleItem =0;
		}

		$aLang = self::$_plugin->getLocalization()->getTranslations();

		$oArtikel = $smarty->getTemplateVars('Artikel');




//		{$oCSS_zubehoer->getLocalization()->getTranslation('css_bundle_in_basket')}

		$smarty->assign('itemTextCounter',json_encode($selectedBundleItemArr));

		// hier werden die Bundles zusammengestellt
		if(Shop::has(self::$_plugin->getID().'_bundleArr')) {
//            	$_bundleArr = Shop::get(self::$_plugin->getID().'_bundleArr');

			// dieser Block sucht mir die erste Staffel aus allen Artikeln heraus
			$bestBreakPoint = 0;
			foreach($_bundleArr as $item) {

				if(!empty(self::getStaffelpreisJson($item->kArtikel))){
					$tmpArr = json_decode(self::getStaffelpreisJson($item->kArtikel),true);
					foreach($tmpArr[0] as $key => $value) {
						if(!$bestBreakPoint || $bestBreakPoint > $key) $bestBreakPoint = $key;
					}
				}
			}

			$smarty->assign('bundleArr',$_bundleArr)
				->assign('bestBreakPoint',$bestBreakPoint)
				->assign('bundleBeschreibung',self::getConfig()->bundleBeschreibung)
				->assign('selector_quantity',self::getConfig()->selector_quantity)
				->assign('selectedBundleItem',$selectedBundleItem)
				->assign('css_bundle_headline', self::getHeadline('bundle'));

			pq(self::getConfig()
				->bundleSelector)
				->{self::getConfig()
					->bundlePosition}(parent::fetchSmarty($config->framework ."/bundle.tpl"));
		}

		if(Shop::has(self::$_plugin->getID().'_zubehoerArr')) {
			$_zubehoerArr = Shop::get(self::$_plugin->getID().'_zubehoerArr');

			foreach($_zubehoerArr as $item) {
				if(self::getZubehoerInputType($item->kArtikel) == 'text') {
					Shop::set(self::$_plugin->getID().'_widthTextfields',true);
					break;
				}
			}
			reset($_zubehoerArr);
			if(Shop::has(self::$_plugin->getID().'_widthTextfields')) {
				$smarty->assign("widthTextfields",true);
			}

			$smarty->assign('zubehoerArr',$_zubehoerArr)
				->assign('zubehoerBeschreibung',self::getConfig()->zubehoerBeschreibung)
				->assign('css_zubehoer_headline', self::getHeadline('accesories'));

			pq(self::getConfig()->zubehoerSelector)
				->{self::getConfig()->zubehoerPosition}(parent::fetchSmarty($config->framework ."/zubehoer.tpl"));
		}

		$smarty->assign('selector_quantity',self::getConfig()->selector_quantity);
		pq('body')->append(parent::fetchSmarty($config->framework ."/zubehoer.js.tpl"));

		if((!empty($config->js) || !empty($config->css)) &&  self::$_hasJsCss === false) {
			self::$_hasJsCss=true;
			if(!empty($config->css)) {
				pq("head")->append("<style>".$config->css."</style>");
			}
			if(!empty($config->js)) {
				pq("body")->append("<script>".$config->js."</script>");
			}
		}

		#}

	}

	public function hookArtikelIncXselling($args_arr) {
		if(self::getConfig()->zubehoerHideXsell=='Y') $args_arr = self::removeXsellingGroup($args_arr,(int) self::getConfig()->zubehoerXsellGroup);
		if(self::getConfig()->bundleHideXsell=='Y') $args_arr = self::removeXsellingGroup($args_arr,(int) self::getConfig()->bundleXsellGroup);
		return $args_arr;
	}


	public function hookArtikelPage($args_arr) {

		$config = self::getConfig();
		$bundleXsellArr=false;
		$zubehoerXsellArr = false;

		if(isset($_POST['jtl_paypal_redirect']) && isset($_POST['zubehoer'])) {
			return self::insertInBasket('zubehoer',true);
		} elseif(isset($_POST['jtl_paypal_redirect']) && isset($_POST['bundle'])) {
			return self::insertInBasket('bundle',true);
		}

		$cParameter_arr = Shop::getParameters();



		if(isset($args_arr['oArtikel']->FunktionsAttribute['unverkaeuflich']) && $args_arr['oArtikel']->FunktionsAttribute['unverkaeuflich']==1) return;


		if($args_arr['oArtikel']->nIstVater != 1 || ($args_arr['oArtikel']->nIstVater == 1 && $args_arr['oArtikel']->kVariKindArtikel > 0) ) {

			if(!empty($args_arr['oArtikel']->FunktionsAttribute['xselling_accesories']) && (int) $args_arr['oArtikel']->FunktionsAttribute['xselling_accesories'] > 0) {
				$xSellingGroup = (int) $args_arr['oArtikel']->FunktionsAttribute['xselling_accesories'];
				$OnlyFromArticle = false;
				if((int) $config->cssRand > 0 ){
					$limit = (int) $config->cssRand;
				} else {
					$limit = 0;
				}
				$rand = true;
			} else {
				$OnlyFromArticle = true;
				$xSellingGroup = self::getConfig()->zubehoerXsellGroup;
				$limit = 0;
				$rand = false;
			}

			$zubehoerXsellArr = self::getXselling($args_arr['oArtikel'],$xSellingGroup,true,false,$limit,$rand,$OnlyFromArticle);


			// ich kann keinen Artikel im Bundle gebrauchen der eine Variante hat die ausgewählt werden muss.
			if($args_arr['oArtikel']->nIstVater==0 && count($args_arr['oArtikel']->Variationen) > 1 ) {

			} elseif(		((!empty($args_arr['kVaterArtikel']) && $args_arr['kVaterArtikel'] > 0) ||  (empty($args_arr['nIstVater']) || $args_arr['nIstVater'] == 0))
				&& $args_arr['oArtikel']->inWarenkorbLegbar == 1
				&& !count($args_arr['oArtikel']->oKonfig_arr)
			) {
				if(!empty($args_arr['oArtikel']->FunktionsAttribute['xselling_bundle']) && (int) $args_arr['oArtikel']->FunktionsAttribute['xselling_bundle'] > 0) {
					$xSellingGroup = (int) $args_arr['oArtikel']->FunktionsAttribute['xselling_bundle'];
					$OnlyFromArticle = false;
					if((int) $config->cssRand > 0 ){
						$limit = (int) $config->cssRand;
					} else {
						$limit = 0;
					}
					$rand = true;
				} else {
					$OnlyFromArticle = true;
					$xSellingGroup = self::getConfig()->bundleXsellGroup;
					$limit = 0;
					$rand = false;
				}

				$bundleXsellArr = self::getXselling($args_arr['oArtikel'],$xSellingGroup,false,true,$limit,$rand,$OnlyFromArticle);
			}

			if($zubehoerXsellArr && count($zubehoerXsellArr)>0)		Shop::set(self::$_plugin->getID().'_zubehoerArr', $zubehoerXsellArr);
			if($bundleXsellArr && count($bundleXsellArr)>1)		Shop::set(self::$_plugin->getID().'_bundleArr', $bundleXsellArr);
		}

	}


	public function putToBasket($kArtikel=0, $quantity=0, $jtl_token='') {
		$db = self::$_db;
		$oEigenschaftwerte_arr = [];

		$oArtikelOptionen = Artikel::getDefaultOptions ();
		$oArtikelOptionen->nMerkmale = 0;
		$oArtikelOptionen->nVariationen = 1;

		$ArtikelObj = new Artikel ();
		$ArtikelObj->fuelleArtikel ( (int) $kArtikel, $oArtikelOptionen );

		if (Product::isParent((int) $kArtikel)) {
			$kArtikel = Product::getArticleForParent((int) $kArtikel);
			$oEigenschaftwerte_arr = Product::getSelectedPropertiesForArticle($kArtikel,false);
			if ((int) $kArtikel > 0) {
				$oEigenschaftwerte_arr = Product::getSelectedPropertiesForVarCombiArticle((int) $kArtikel);
			} else {
				$oEigenschaftwerte_arr = Product::getSelectedPropertiesForArticle((int) $kArtikel,false);
			}
		} elseif (isset($ArtikelObj->kEigenschaftKombi) && (int) $ArtikelObj->kEigenschaftKombi > 0) {
			$oEigenschaftwerte_arr = \JTL\Helpers\Product::getVarCombiAttributeValues((int) $kArtikel);
		} else {
			$oEigenschaftwerte_arr = Product::getSelectedPropertiesForArticle((int) $kArtikel,false);
		}

		$_POST['jtl_token'] = $jtl_token;

		if(CartHelper::addProductIDToCart((int)$kArtikel, (float) $quantity, $oEigenschaftwerte_arr,1) === false) {
			self::$artikelNotInsertArr[] = $ArtikelObj;
		} else {
			self::$artikelIsInsertArr[] = $ArtikelObj;
			return true;
		}
		return false;
	}



	public function insertInBasket($type='zubehoer',$isPayPalRedirect=false) {

#        self::stopRedirectToBasket();

		if(isset($_POST['jtl_token'])) {
			$token = $_POST['jtl_token'];
		} else $token ='';

		$quantity = (isset($_POST['quantity'])) ? floatval($_POST['quantity']) : 1;

		if($type=='zubehoer') {
			foreach($_POST['zubehoer'] as $itemId => $quantity) {
				self::putToBasket($itemId,$quantity,$token);
			}
		} elseif($type=='bundle') {

			$quantity = (isset($_POST['quantity'])) ? floatval($_POST['quantity']) : 1;
			if($isPayPalRedirect===true && isset($_SESSION['Warenkorb']->PositionenArr) ) {
				foreach($_SESSION['Warenkorb']->PositionenArr as &$pos) {
					if($pos->kArtikel == $_POST['a']) {
						$pos->nAnzahl -= \floatval($_POST['anzahl']);
						break;
					}
				}
				$_SESSION['Warenkorb']->loescheNullPositionen();
			}
			foreach($_POST['bundle'] as $key => $itemId) {
				self::putToBasket($itemId,$quantity,$token);
			}
		}
#        return [$this->$artikelIsInsertArr, $this->$artikelNotInsertArr];
	}


	public function hookIoHandleRequest($data)    {
		$cfg = self::getConfig();
		if (!isset($_REQUEST['io']) || $_REQUEST['io'] != self::$_plugin->getPluginID()) return;
		$smarty = Shop::Smarty();
		$config = self::getConfig();
		$aLang = self::$_plugin->getLocalization()->getTranslations();

		if($_POST['action'] != 'putInBasket' && $_POST['action'] != 'putZubehoerInBasket') {
			return;
		}

		require_once PFAD_ROOT.PFAD_INCLUDES.'warenkorb_inc.php';

		$showXsell= false;
		$smarty = Shop::Smarty();
		$conf      = Shop::getSettings([CONF_KAUFABWICKLUNG,CONF_GLOBAL]);
		if ($conf['kaufabwicklung']['warenkorb_xselling_anzeigen'] === 'Y') {
			if(!file_exists($smarty->getTemplateDir ( 'frontend' ).'/snippets/product_slider.tpl')) {
				$showXsell=false;
			} else {
				$showXsell=true;
			}
		}

		if($_POST['action'] == 'putInBasket') {
			self::insertInBasket('bundle');
		} elseif($_POST['action'] == 'putZubehoerInBasket') {
			self::insertInBasket('zubehoer');
		}


		if(!empty(self::$artikelIsInsertArr) && count(self::$artikelIsInsertArr)>0) {
			$smarty->assign("pushedArtikel", self::$artikelIsInsertArr);
		}
		$smarty->assign('NettoPreise', (isset($_SESSION['Kunde']->NettoPreise)) ? (int) $_SESSION['Kunde']->NettoPreise : 0);

		if($showXsell) {
#            $smarty->assign('Xselling', gibXSelling())
#                ->assign('showXsell', $showXsell);
		}


		if(count(self::$artikelNotInsertArr)) {
			$smarty->assign("css_push_basket_error",$aLang['css_push_basket_error'])
				->assign("notPushedArtikel",self::$artikelNotInsertArr);
		}

		$isHypno = false;
		$script = array();
		$content = parent::fetchSmarty($config->framework .'/pushed_success.tpl');

		if($cfg->showModal == 'Y') {
			$script[] = '$.cssZb.openModalNotice("","","'.Text::convertUTF8($aLang['css_push_basket_success']).'",data.content,'.$isHypno.');';
		}

		$script[] = 'if(typeof $.evo !== "undefined" && typeof $.evo.basket !== "undefined") { $.evo.basket().updateCart(); }';
		$script[] = '$("#bundle-basket-button").attr("disabled",false);';
		$script[] = '$("[name=\"inWarenkorb\"]:disabled").attr("disabled",false);';

		parent::out($content,join("\n",$script));
		exit;

	}

	public function hookCssJsList(&$args_arr) {
		$cfg = self::getConfig();
		include parent::getPluginPath().'frontend/inc/css_js.php';

	if(!empty($cssArr)) {
		foreach($cssArr as $css) {
			$css['path'] = str_replace("#FRAMEWORK#",$cfg->framework,$css['path']);
			$args_arr['groups']['plugin_css'] = parent::insertCSS($args_arr['groups']['plugin_css'], $css['file'],$css['override'],$css['path']);
		}
	}

	if(!empty($jsArr)) {
		foreach($jsArr as $js) {
			$js['path'] = str_replace("#FRAMEWORK#",$cfg->framework,$js['path']);
			$args_arr['groups']['plugin_js_body'] = parent::insertJS($args_arr['groups']['plugin_js_body'], $js['file'],$js['override'],$js['path']);
		}
	}

		return $args_arr;
	}

}
